'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Input = function (_Component) {
  (0, _inherits3.default)(Input, _Component);

  function Input(props, context) {
    (0, _classCallCheck3.default)(this, Input);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Input).call(this));

    _initialiseProps.call(_this);

    var collectionName = props.collectionName;
    var docId = props.docId;
    var field = props.field;

    var value = context.model.get(collectionName, docId, field);

    _this.state = {
      value: value
    };
    return _this;
  }

  (0, _createClass3.default)(Input, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props;
      var collectionName = _props.collectionName;
      var docId = _props.docId;

      var doc = this.context.model.doc(collectionName, docId);

      doc.on('stringInsert', this.onStringInsert);
      doc.on('stringRemove', this.onStringRemove);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _props2 = this.props;
      var collectionName = _props2.collectionName;
      var docId = _props2.docId;

      var doc = this.context.model.doc(collectionName, docId);

      doc.removeListener('stringInsert', this.onStringInsert);
      doc.removeListener('stringRemove', this.onStringRemove);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props;
      var type = _props3.type;
      var children = _props3.children;
      var value = this.state.value;


      if (children) {
        return (0, _react.cloneElement)(children, {
          ref: 'input',
          value: value,
          onChange: this.onChange
        });
      }

      if (type === 'textarea') {
        return _react2.default.createElement('textarea', (0, _extends3.default)({}, this.props, {
          ref: 'input',
          value: value,
          onChange: this.onChange
        }));
      }

      return _react2.default.createElement('input', (0, _extends3.default)({}, this.props, {
        ref: 'input',
        value: value,
        onChange: this.onChange
      }));
    }
  }]);
  return Input;
}(_react.Component);

Input.contextTypes = {
  model: _react.PropTypes.object
};
Input.propTypes = {
  type: _react.PropTypes.string,
  collectionName: _react.PropTypes.string,
  docId: _react.PropTypes.string,
  field: _react.PropTypes.string,
  children: _react.PropTypes.any
};
Input.defaultProps = {
  type: 'input'
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.onStringInsert = function (eventField, index, howMany) {
    var _props4 = _this2.props;
    var collectionName = _props4.collectionName;
    var docId = _props4.docId;
    var field = _props4.field;

    if (eventField !== field) return;

    var value = _this2.context.model.get(collectionName, docId, field);
    var input = _this2.refs.input;

    if (input.refs && input.refs.input) input = input.refs.input;

    var _input = input;
    var selectionStart = _input.selectionStart;
    var selectionEnd = _input.selectionEnd;

    if (selectionStart > index + howMany) selectionStart = selectionStart + howMany;
    if (selectionEnd > index + howMany) selectionEnd = selectionEnd + howMany;

    _this2.setState({
      value: value
    });
    input.setSelectionRange(selectionStart, selectionEnd);
  };

  this.onStringRemove = function (eventField, index, howMany) {
    var _props5 = _this2.props;
    var collectionName = _props5.collectionName;
    var docId = _props5.docId;
    var field = _props5.field;

    if (eventField !== field) return;

    var value = _this2.context.model.get(collectionName, docId, field);
    var input = _this2.refs.input;

    if (input.refs && input.refs.input) input = input.refs.input;

    var _input2 = input;
    var selectionStart = _input2.selectionStart;
    var selectionEnd = _input2.selectionEnd;

    if (selectionStart > index) selectionStart = selectionStart - howMany;
    if (selectionEnd > index) selectionEnd = selectionEnd - howMany;

    _this2.setState({
      value: value
    });
    input.setSelectionRange(selectionStart, selectionEnd);
  };

  this.onChange = function (event) {
    var _props6 = _this2.props;
    var collectionName = _props6.collectionName;
    var docId = _props6.docId;
    var field = _props6.field;
    var value = event.nativeEvent.target.value;

    _this2.context.model.stringDiff([collectionName, docId, field], value);
  };
};

exports.default = Input;
module.exports = exports['default'];